#ifndef H_RLINETD
#define H_RLINETD

#include <signal.h>
#include <sysexits.h>
#include <syslog.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/resource.h>
#include <unistd.h>
#include <netinet/in.h>

#include "bytecode.h"

struct rl_cleanup {
	int type;
	void *data;
	struct rl_cleanup *next;
};

struct rl_instance {
	struct sockaddr *sin;
	int sinlen;
	struct rusage rusage;
	int status;
	time_t start;
	volatile time_t stop;
	int sock;
	int reg;
};

extern int rl_debug;

void rl_warn(const char *, ...);
void rl_fatal(int, const char *, ...);

void run_bytecode(rl_opcode_t *, struct rl_instance *);

extern fd_set rfds;
extern struct rl_cleanup *rl_cleanups;

void read_hook(int, rl_opcode_t *, struct rl_instance *);
void read_unhook(int);
void write_hook(int, rl_opcode_t *, struct rl_instance *);
void write_unhook(int);
void all_unhook();

void listeners_clear(int);
void listeners_set(int);

#endif /* !H_RLINETD */
